.686			
.XMM
.model 	flat, stdcall
option 	casemap:none

include	c:\masm32\include\windows.inc
include	c:\masm32\include\kernel32.inc
include	c:\masm32\include\masm32.inc
include	c:\masm32\macros\macros.asm
include	c:\masm32\macros\timers.asm
includelib	c:\masm32\lib\kernel32.lib
includelib	c:\masm32\lib\masm32.lib

Main				proto


lingo32				proto
lostcauz32        proto 
AnotherStringReverse PROTO :DWORD,:DWORD

.data

	LOOP_COUNT	EQU	100000001		; 1M iterations per timing result

    align 4
	  str1 db 'abcdefghijklmnopqrstuvwxyzabc',0
	  lenstr1 EQU $-str1-1
	align 4
      str2 db 64 dup(0)
      str3 db 64 dup(0) 

	  str4 db 'abcdefghijklmnopqrstuvwxyzabc',0
	  lenstr4 EQU $-str4-1

  align 4
	  str5 db 'abcdefghijklmnopqrstuvwxyzabc',0
	  lenstr5 EQU $-str5-1


msgstr db "Cycles: %d", 0
Strlingo					DB  "RevStr - lingo     : ",0
Strlostcauz				DB  "RevStr - lostcauz  : ",0
StrRatch				    DB  "RevStr - Ratch     : ",0
StrNightWare			DB  "RevStr - NightWare : ",0
 retva  dd 0


.data?
    buff db 32 dup(?)



.code
Start:
	Invoke	Main
	Invoke	ExitProcess, 0
Main	Proc
	;print	chr$(" ReverseStr tests ",13,10)
	mov	eax, input(" Please terminate any high-priority tasks and press ENTER to begin.")
    	print	chr$(13,10,13,10," Input string ->")
			print	addr str1
	   	print	chr$(13,10,13,10)
; ------------------------------------------------------------------------------------------------------------------------------------------------------------  

; ------------------------------------------------------------------------------------------------------------------------------------------------------------  
comment * ReverseStr by lostcauz *
	print	addr Strlostcauz
	counter_begin	LOOP_COUNT, HIGH_PRIORITY_CLASS
		call lostcauz32 
	;	mov	retva, eax
	counter_end
	print	ustr$(eax)
	print	chr$(" clocks. Result: ")
	print	addr str3
	;mov	eax, retva
	;print	ustr$(eax)
	print	chr$(" ",13,10)
	invoke	Sleep, 250

; ------------------------------------------------------------------------------------------------------------------------------------------------------------  
	
comment * ReverseStr by lingo *
	print	addr Strlingo
	counter_begin	LOOP_COUNT, HIGH_PRIORITY_CLASS
		call Lingo32
	;	mov	retva, eax
	counter_end
	print	ustr$(eax)
	print	chr$(" clocks. Result: ")
	print	 addr str2
	;mov	eax, retva
	;print	ustr$(eax)
	print	chr$(" ",13,10)
	invoke	Sleep, 250
; ------------------------------------------------------------------------------------------------------------------------------------------------------------  
comment * ReverseStr by Ratch *
	print	addr StrRatch
   	mov eax, offset str1
	mov	edx, offset str4
	@@:
	mov cl, [eax]
	inc eax
	mov  [edx],cl
	inc edx
	test	cl, cl
	jne	@b


   	counter_begin	LOOP_COUNT, HIGH_PRIORITY_CLASS
	push offset str4
	push lenstr4
	call REVBSTR
	;	mov	retva, eax
	counter_end
	print	ustr$(eax)
	print	chr$(" clocks. Result: ")
	print	addr str4
	;mov	eax, retva
	;print	ustr$(eax)
	print	chr$(" ",13,10)
	invoke	Sleep, 250
; ------------------------------------------------------------------------------------------------------------------------------------------------------------  

    comment * ReverseStr by NightWare *
	print	addr StrNightWare

	mov eax, offset str1
	mov	edx, offset str5
	@@:
	mov cl, [eax]
	inc eax
	mov  [edx],cl
	inc edx
	test	cl, cl
	jne	@b


	counter_begin	LOOP_COUNT, HIGH_PRIORITY_CLASS
	push lenstr5
	push offset str5
	call AnotherStringReverse
	;	mov	retva, eax
	counter_end
	print	ustr$(eax)
	print	chr$(" clocks. Result: ")
	print	 addr str5
	;print	str$(eax)
	print	chr$(" ",13,10)
	invoke	Sleep, 250
; ------------------------------------------------------------------------------------------------------------------------------------------------------------  
	mov	eax, input(13,10," Press ENTER to exit...")
	ret
Main	EndP


; ------------------------------------------------------------------------------------------------------------------------------------------------------------  
comment 		* ReverseStr by lostcauz *
align 		16
;##########################################################################
OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE
lostcauz32 proc
    lea esi,str1            ; load effective address of string 
    lea edi,str3            ; load effective address of buffer
    mov ecx,[sizeof str1-1] ; determine length of string less terminating '0'
    mov ebx,ecx             ; load length for manipulation
    cmp ecx,4               ; ensure string is large enough for dword manipulations
    jb l1                   ; if not, work with one byte at a time
    and ebx,3               ; test dword alignment by checking two least significant bytes
    jz l2                   ; if zero it's 4 byte aligned
    cmp ebx,3               ; test if both lsb's set
    jnz @f                  ; next test
    sub ecx,1               ; both lsb's are set, work byte by byte until dword aligned
    mov al,[esi+ecx]        ; load last character
    sub ebx,1               ; decrement for next test
    mov [edi],al            ; save byte to beginning of buffer
    add edi,1               ; increment buffer position for next byte

@@: cmp ebx,2               ; test only bit 1
    jnz @f                  ; next test
    sub ecx,1               ; decrement string position
    mov al,[esi+ecx]        ; load byte
    sub ebx,1               ; prepare for next byte
    mov [edi],al            ; save byte to buffer
    add edi,1               ; increment buffer position

@@: cmp ebx,1               ; test only bit 0
    jnz l1                  ; next
    sub ecx,1               ; update string position
    mov al,[esi+ecx]        ; load byte
    mov [edi],al            ; store to buffer
    add edi,1               ; update buffer position
    jmp l2                  ; move on to dword manipulation
    
l1: sub ecx,1               ; string is less than 4 characters
    mov al,[esi+ecx]        ; load byte
    mov [edi],al            ; store byte
    add edi,1               ; update buffer
    or ecx,ecx              ; last byte?
    jz l3                   ; done
    jmp l1                  ; continue
    
l2: sub ecx,4               ; back up 4 bytes
    jnz @f                  ; if > 0 go to dword loading loop
    mov eax,[esi+ecx]       ; else load the only dword
    bswap eax               ; reverse dword 
    mov [edi],eax           ; load dword
    jmp l3                  ; done
       
@@: mov eax,[esi+ecx]       ; load dword 
    bswap eax               ; swap bytes
    mov [edi],eax           ; store dword
    add edi,4               ; update buffer for next dword
    sub ecx,4               ; back up to next dword
    jnz @b                  ; loop
    mov eax,[esi]           ; load last dword
    bswap eax               ; swap
    mov [edi],eax           ; store and done.  
l3: 
	ret 
lostcauz32 endp
OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef


OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE
;...........................................................................................
comment * ReverseStr by Lingo *
align	16
db  0A4h, 24h, 0, 0, 0, 0 , 8Dh, 9Bh,  0, 0, 0, 0,90 
Lingo32	proc	
				mov		ecx, sizeof str1-1
				xor		eax, eax
				cmp		ecx, 4
			   	mov		byte ptr [str2+ecx], al
				jl			Bytes3
				push		ebx
@@:
				mov		edx, dword ptr [str1+eax]
				add		eax, 4
				add		ecx, -8
				mov		ebx, dword ptr [str1+eax+ecx]
				bswap	edx
				mov		dword ptr [str2+eax+ecx], edx
				bswap	ebx
				mov		dword ptr [str2+eax-4], ebx
				jg			@b
				pop		ebx
				ret
align	16
Bytes3:
				movzx	edx, byte  ptr [str1]
				cmp		ecx, 1
				mov		byte ptr [str2+ecx-1], dl
				jle			End3
				mov		dl, byte  ptr [str1+1]
				cmp		ecx, 2
				mov		byte ptr [str2+ecx-2], dl
				jle			End3
				mov		dl, byte  ptr [str1+2]
				mov		byte ptr [str2+ecx-3], dl
End3:
				ret
Lingo32	endp		
OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

      
;*******************************************************************************
; REVBSTR:   Reverses the bytes of an ASCII string.                            *
;                                                                              *
; Called by: PUSH <address of string>                                          *
;            PUSH <string length>                                              *
;            CALL REVBSTR                                                      *
;                                                                              *
; Returns:   Nothing                                                           *
;                                                                              *
; Notes:     This subroutine conforms with WIN32 conventions regarding         *
;            register preservation and stack balancing.                        *
;                                                                              *
; Coder:     Ratch                                                             *
;*******************************************************************************
REVBS$ STRUC
  RETURN    DWORD ?
RV1$ = $
  STRLEN    DWORD ?
  SADR      DWORD ?
RV2$ = $
REVBS$ ENDS

RVBS$ EQU ESP.REVBS$            ;save some typing

REVBSTR:                        ;it all begins here
PUSH ESI                       ;save register
PUSH EDI                       ;save register
MOV EAX,[RVBS$.STRLEN+2*DWORD] ;string length
MOV ESI,[RVBS$.SADR+2*DWORD]   ;string start address
SHRD EDX,EAX,3                 ;mod 8
PUSH EBX                       ;save register
LEA EDI,[ESI+EAX-DWORD]        ;string end address - DWORD
SHR EDX,32-3                   ;EDX = remainder
SHR EAX,3                      ;divide by 8

.IF EDX > 3
   INC EAX                      ;increase loop count
   XOR EDX,EDX                  ;remainder is set to zero
.ENDIF 

.WHILE EAX                     ;8 bytes moved each time through loop
   MOV ECX,[ESI]                ;pick up 4 bytes
   MOV EBX,[EDI]                ;pick up 4 bytes
   BSWAP ECX
   BSWAP EBX
   MOV [EDI],ECX                ;put down 4 bytes
   MOV [ESI],EBX                ;put down 4 bytes
   ADD ESI,DWORD                ;move string end pointer
   SUB EDI,DWORD                ;move string beginning pointer
   DEC EAX                      ;loop counter
.ENDW

.IF EDX                        ;if remainder
   ADD EDI,DWORD-BYTE           ;adjust pointer
   MOV CL,BYTE PTR [ESI]        ;pick up byte
   MOV BL,BYTE PTR [EDI]        ;pick up byte
   MOV BYTE PTR [EDI],CL        ;put down byte
   MOV BYTE PTR [ESI],BL        ;put down byte
.ENDIF

POP ESI                        ;restore register
POP EDI                        ;restore register
POP EBX                        ;restore register
RET RV2$-RV1$                  ;return home



AnotherStringReverse PROC StrAddr:DWORD,StrSize:DWORD
ALIGN 16
;db 0cch
push ebx
push esi
push edi

mov esi,StrAddr
mov eax,StrSize
lea edi,[esi+eax]; if you use SIZEOF => lea edi,[esi+eax-1]
mov ebx,eax
and eax,00000000000000000000000000000111b
shr eax,1; to eliminate impair values
and ebx,11111111111111111111111111111000b

;test ebx,ebx; no dword ? (useless coz the previous and fix the zero flag)
jz Label2

Label1:sub edi,4; big string algo
mov edx,DWORD PTR [edi]
mov ecx,DWORD PTR [esi]
bswap ecx
bswap edx
mov DWORD PTR [esi],edx
mov DWORD PTR [edi],ecx
add esi,4
sub ebx,8
jnz Label1

Label2:test eax,eax; no byte ?
jz Label4

Label3:sub edi,1; small string algo
mov dh,BYTE PTR [edi]
mov dl,BYTE PTR [esi]
mov BYTE PTR [esi],dh
mov BYTE PTR [edi],dl
add esi,1
sub eax,1
jnz Label3
Label4:
pop edi
pop esi
pop ebx
ret
AnotherStringReverse ENDP

End	Start




